//#define USE_EXTAP_KEY_EXTEND        //comment this to use remote extender

extern bool debug;
extern bool active;
extern int main_x, main_y, main_w, main_h;
extern int sub_x, sub_y, sub_w, sub_h;
extern int sub_channel_number;

#ifdef USE_EXTAP_KEY_EXTEND
//
//local key defines (missing in key.h)
//
#define RKEY_TvSTB      0x10022       //was RKEY_TvSat
#define RKEY_Options    0x10010

#define RKEY_List       0x10018       //shared with RKEY_TvRadio

#define RKEY_Right      0x10015       //shared with RKEY_VolUp
#define RKEY_Left       0x1000f       //shared with RKEY_VolDown
#define RKEY_Up         0x10012       //shared with RKEY_ChUp
#define RKEY_Down       0x1001d       //shared with RKEY_ChDown

#define RKEY_Pip        0x10041
#define RKEY_Filelist   0x10042       //or RKEY_PlayList
#define RKEY_Text       0x10043

#define RKEY_Red        0x1003f
#define RKEY_Green      0x10024
#define RKEY_Yellow     0x10025
#define RKEY_Blue       0x10026

#define RKEY_White      0x1003e
#define RKEY_PipSwap    0x10040

//unmapped key values
#define exRKEY_TvRadio  0x1000e       //0x10018 (RKEY_List)    remapped to 0x1000e (RKEY_Uhf)
#define exRKEY_Exit     0x10013       //0x10017 (RKEY_VolDown) remapped to 0x10013 (RKEY_AudioTrk)

#define exRKEY_VolUp    0x10020       //0x10015 (RKEY_Right)   remapped to 0x10020 (RKEY_Fav )
#define exRKEY_VolDown  0x10017       //0x1000f (RKEY_Left)    remapped to 0x10017 (RKEY_Exit)
#define exRKEY_ChUp     0x10021       //0x10012 (RKEY_Up)      remapped to 0x10021 (RKEY_Subt)
#define exRKEY_ChDown   0x10037       //0x1001d (RKEY_Down)    remapped to 0x10037 (RKEY_Teletext)

#define RKEY_None       0x0

#define RAWKEY_Up               RKEY_Up                 //0x100
#define RAWKEY_Down             RKEY_Down               //0x101
#define RAWKEY_Right            RKEY_Right              //0x102
#define RAWKEY_Left             RKEY_Left               //0x103
#define RAWKEY_List_TVRad       exRKEY_TvRadio          //0x104
#define RAWKEY_ChUp_Subt        exRKEY_ChUp             //0x107
#define RAWKEY_VolUp_Fav        exRKEY_VolUp            //0x109
#define RAWKEY_VolDown_Exit     exRKEY_VolDown          //0x11c
#define RAWKEY_tv_radio_Uhf     exRKEY_TvRadio          //0x143
#define RAWKEY_ChDown_Teletext  exRKEY_ChDown           //0x147
#endif


#define is_firmware(p) (((p&0xfc000000)==0x80000000) ? 1 : 0)

//hooks
extern int scale_enabled;
extern int scale_hook_id;
int apply_scale_hook();
int remove_scale_hook();
dword scale_hook(dword param1, dword param2);

extern int wss_enabled;
extern int wss_hook_id;
int apply_wss_hook();
int remove_wss_hook();
dword wss_hook(dword param1, dword param2);

extern int open_exTras(void);
extern void close_exTras(void);
extern void display_aspect_ratio();
extern int aspect_enabled;
